import express from 'express';
import { Feed } from 'feed';

import utils from './utils.mjs';
import db from './db.mjs';

// Feed

const router = express.Router();

export default router;

router.use(express.json());

const domain = process.env.DOMAIN || utils.DEFAULT_DOMAIN;

router.get('/:site', utils.limiter(500), (req, res) => {
    const site = req.params.site;

    var feed = new Feed({
        title: 'UCS',
        description: 'תגובות עבור האתר ' + site,
        id: domain + '/feed/' + site,
        link: domain,
        language: 'he'
    });

    const comments = db.siteComments(site);

   for (const comment of comments) {
       feed.addItem({
           title:  `New message by '${comment.user}' on ${comment.path}`,
           description: comment.message,
           id: `${comment.site}/${comment.path}#comment-${comment.id}`,
           link: `${comment.site}/${comment.path}#comment-${comment.id}`,
           date: new Date(comment.published)
       });
   }

    var xml = feed.atom1();

    res.set('Content-Type', 'text/xml');
    res.send(xml);
});
